module configReaderHelper;
import std.stdio;


// unit tesztek a program futtatása előtt futnak le,
// de csak akkor, ha a program -unittest kapcsolóval volt fordítva,
// különben nem fordulnak bele a programba.
unittest
{
  writeln("ConfigReaderHelper unit tesztek futtatása");
  writeln();
}

// Mivel az első paraméter egy tömb, ezért property-ként meghívható
// stringArray.contains(element)
// formában.
// Ez csak akkor működik, ha az első paraméter egy tömb.
/**
 * Megnézi, hogy az adott tömb tartalmazza-e az adott elemet.
 * param stringArray A tömb, melyben keresünk.
 * param element Az elem, melyet a tömbben keresünk.
 */
bool contains(const string[] stringArray, string element)
{
  for(int i = 0; i < stringArray.length; ++i)
  {
    if(stringArray[i] == element)
    {
      return true;
    }
  }
  return false;
}

unittest
{
  writeln("contains üres tömbre teszt");
  assert( ! contains([], "dio") );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("contains egyelemű tömbre tesztek");
  assert( contains(["dio"], "dio") );
  assert( ! contains(["dió"], "dio") );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("contains funkcionális tesztek");
  assert( contains(["alma","korte", "dió"], "dió") );
  assert( ! contains(["alma","korte", "dió"], "dio") );
  assert( contains(["alma","körte", "dió"], "körte") );
  assert( ! contains(["alma","körte", "dió"], "korte") );
  assert( contains(["alma","körte", "dió"], "alma") );
  assert( ! contains(["alma","körte", "dió"], "semmi") );
  assert( contains(["alma","alma", "dió"], "alma") );
  assert( contains(["alma","alma", "dió"], "dió") );
  assert( ! contains(["alma","alma", "dió"], "semmi") );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("contains property-ként teszt");
  assert( ! ["alma","alma", "dió"].contains("semmi") );
  writeln("Siker");
  writeln();
}

// Mivel az első paraméter egy tömb, ezért property-ként meghívható
// stringArray.toString
// formában (zárójelek nélkül).
/**
 * A megadott tömböt alakítja át szöveg formátumra úgy, hogy az elemeket egymás után írja,
 * vesszővel elválasztva.
 * param stringArray A tömb melyet szöveggé szeretnénk alakítani.
 */
string toString(const string[] stringArray)
{
  string result = "";
  for(int i = 0; i < stringArray.length; ++i)
  {
    result ~= stringArray[i];
    if( i != stringArray.length-1 )
    {
    result ~= ", ";
    }
  }
  return result;
}

unittest
{
  writeln("toString üres tömbre teszt");
  assert( [].toString == "" );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("toString egyelemű tömbre teszt");
  assert( ["Something"].toString == "Something" );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("toString többelemű tartalmazó tömbre teszt");
  assert( ["cat", "dog", "mouse"].toString == "cat, dog, mouse" );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("toString többelemű, szóközt tartalmazó tömbre teszt");
  assert( ["one1  one2", "twoa twob twoc", "three"].toString == "one1  one2, twoa twob twoc, three" );
  writeln("Siker");
  writeln();
}

unittest
{
  writeln("ConfigReaderHelper unit tesztek sikeresen lefutottak.");
  writeln();
  writeln();
  writeln();
  writeln();
}

