#!/usr/bin/env rdmd

import std.stdio;
import configReader;

void printConfigOption(ConfigReader configReader, string configOption)
{
  writeln(configOption ~ ": " ~ configReader.getValue(configOption));
}

void main() {
  // Konfig olvasást a ConfigReader osztály implementálja (lásd: configReader.d)
  ConfigReader configReader = new ConfigReader();

  // Konfig fájlbeli lehetséges opciók hozzáadása
  // Ha alapértelmezett érték nem readonly vagy readwrite, akkor az előfeltétel sérül.
  // Ebben az esetben egy kivételt fog dobni a program, jelezve,
  // hogy a programozó rossz kódsort írt.
  configReader.addOption("readingmode", "readonly", ["readonly", "readwrite"]);
  // admin kötelező mező, hisz nincs alapértelmezett értéke.
  configReader.addOption("admin", null, ["yes", "no"]);
  configReader.addOption("mynickname", "Anonymus", null);
  // myusername kötelező mező, hisz nincs alapértelmezett értéke.
  configReader.addOption("myusername", null, null);

  try
  {
    // Konfig fájl olvasása.
    configReader.fillConfigValesFromFile( "config file.conf" );

    // Ha nem történt kivétel dobás, akkor az olvasott értékeket lehet használni.
    // Ha kivétel történt, akkor a konfig fájl tartalma nem volt megfelelő,
    // a kiváltó ok megtekinthető a dobott kivételben.
    printConfigOption(configReader, "readingmode");
    printConfigOption(configReader, "admin");
    printConfigOption(configReader, "mynickname");
    printConfigOption(configReader, "myusername");
  }
  catch(ConfigReaderException exception)
  {
    // A kiváltó ok a kivételbe beállított üzenetben található.
    writeln( exception.msg );
  }
}

